
utility asc_reader "ASC Reader"
(



fn skip_to_eol filename =
(
local str = ""
local end_of_line = false
	while (not end_of_line) do
	(
	str = readchar filename
	if str == "\n" then end_of_line = true
	)
)



fn read_word filename =
(
local accu_read = ""
local str = ""
local end_of_word = false
local b_open = false
while (not end_of_word) do
	(
	try
	(
	str = readchar filename
	)
	catch
	(
	str = "EOF"
	end_of_word = true
	)
	if str == "\"" and b_open==false then 
			(
			str=""
			b_open = true
			)
			
	if str == "\"" and b_open==true then 
			(
			str=""
			b_open = false
			)
			
			
	if str == "\t" then str=" "
	
	if str == " " and b_open == false then 
		(
		if accu_read != "" then end_of_word = true	
		str = ""
		)
		
	if str == "," then
		(
		if accu_read != "" then end_of_word = true	
		str = ""
		)	
		
	if str == ":" then
		(
		if accu_read != "" then end_of_word = true	
		str = ""
		)	
		
	if str == "=" then
		(
		if accu_read != "" then end_of_word = true	
		str = ""
		)	

		if str == "(" then str = ""
		if str == ")" then str = ""


		
		
	if str == "\n" then 
		(
		if accu_read != "" then end_of_word = true	
		str = ""
		)
		
	accu_read = accu_read + str	
	)
--	format "%\n" ("->"+accu_read	)
	
accu_read

)


local mesh_reading = false
local node_mapped = false 
local read_vertex = false
local face_read = false
local read_omni = false
local read_camera = false
local read_target_pos = false
local read_cam_pos = false
local read_spot = false
local read_smoothing = false
local wait_for_creation = 0
local face_index = 0

group "About..."
(
label ascii01 "ASCreader"
label ascii02 "Beta 0.3 - 4/9/1999"
label ascii03 "(c) Bobo's Rendert**ls"
label ascii04 "http://gfxcentral.com/bobo/"
label ascii05 "BattleCruiser Release"

)

group "Batch Processing Options"
(
checkbutton batch_import "Batch Import Folder" checked:false width:140 align:#center highlightcolor:(color 255 200 200)

)
group "MAX File Output"
(
checkbox save_max_file "Save MAX File" checked:true
checkbox use_separate_folder "Use Custom Folder" checked:false
button get_custom "Get" align:#left across:2 width:25 height:17
edittext custom_folder text:"c:\\temp\\" fieldwidth:110 align:#right
)

on get_custom pressed do
(
custom_get = getSavePath caption:"Select Folder for MAX Output"
if custom_get != undefined then custom_folder.text = (custom_get+"\\")
)


button open_file "Read ASC File" width:140 height:35
checkbox reset_scene "Replace Current Scene" checked:true

on open_file pressed do
(

local mat_array = #()
local matid_array = #()
local tvertex_array = #()

num_mats = 0
o_file_array = #()
	
	if batch_import.checked then
	(
	in_path = getSavePath caption:"Select Folder to Batch-Import .ASC"
	o_file_array = getFiles (in_path+"\\*.asc")
	txt = o_file_array.count as string +" Files Found in Folder "+in_path
	format "%\n" txt	
	)
	else
	(
	o_file_array[1] = GetOpenFileName caption:"Import ASC file:" types:("3D Studio ASCII *.ASC|*.ASC|")
	)
	
for ofl = 1 to o_file_array.count do
(
o_file = o_file_array[ofl]
	
	if o_file !=undefined then
	(
	
	
if reset_scene.checked then 
	(
	resetmaxfile #noprompt
	max utility mode
	txt = "RESET SCENE."
	format "%\n" txt
	)	
	
	
	
	file_name = openFile(o_file)
	max_file = (getFilenameFile o_file) + ".max"
	if use_separate_folder.checked then
	(
	max_file = custom_folder.text + max_file
	)
	else
	(
	max_file = getFilenamePath(o_file) + max_file
	)
	not_eof = true
	format "%\n" "=============================="
	format "%\n" "ASC Importer Reading"
	format "%\n" o_file
	format "%\n" "=============================="
	while not_eof do
	(
	word = read_word file_name


	
		if read_smoothing then
		(
		sgroup= (word as float)
			if sgroup != undefined and word != "EOF" then
				(
				smooth_array[face_index+1] += (2 ^ (sgroup-1))
				)
				else
				(
				read_smoothing = false
				wait_for_creation = 3
				)
		)				
				
			if (face_index+1) == face_count and wait_for_creation == 3 then
			(
			wait_for_creation = 0
			if tvertex_array.count > 0 then
				(
				m = mesh vertices:vertex_array faces:face_array materialIds:matid_array tverts:tvertex_array
				update m
				setnumtverts m vertex_array.count true
				buildTVfaces m
				for z = 1 to tvertex_array.count do settvert m z tvertex_array[z]
				for z = 1 to face_array.count do settvface m z face_array[z]
				update m
				)
				else
				(
				m = mesh vertices:vertex_array faces:face_array materialIds:matid_array
				)
				
				if smooth_array[1] != 0 then
				(
				txt = "...Applying Smoothing Groups..."
				format "%\n" txt
				addmodifier m(smooth autosmooth:false smoothinggroups:0)
				collapsestack m
			
				for i = 1 to face_count do
					(
					setfacesmoothgroup m i (smooth_array[i])
					)
			
				)--end smooth
				
				
				
				txt = "...Setting Edge Visibility..."
				format "%\n" txt
				for i = 1 to face_count do
					(
					setedgevis m i 1 vis_ab[i]
					setedgevis m i 2 vis_bc[i]
					setedgevis m i 3 vis_ac[i]
					)
			
				txt = ">EditableMesh "+name_string+" created."
				format "%\n" txt
				
				update (m)
			m.name = uniquename (name_string)
			
			if mat_array.count > 0 then
			(
			new_mat = multimaterial name:name_string numsubs:mat_array.count
			for o = 1 to mat_array.count do
				(
				try
				(
				new_standard = standardmaterial name:mat_array[o] 
				bmp_file_name = (getFilenamePath o_File) + ("\\"+mat_array[o]+".BMP")
				print bmp_file_name
				check_for_file = (getfiles bmp_file_name)
				if check_for_file.count > 0 then new_bmp = bitmaptexture filename:bmp_file_name
				new_standard.diffusemap=new_bmp
				if not max_ver2 then showtexturemap new_standard new_bmp true
				new_mat[o]= new_standard
				)
				catch ()
				)
			m.material = new_mat	
			mat_array = #()
			)
			
			)--end if smooth
		








	if word == "EOF" then 
		(
		not_eof = false
		format "%\n" "End Of File Reached."
		)
		
	if word == "Named" then 
		(
		word = read_word file_name
		if word == "object" then
			(
			name_string = read_word file_name
			txt = "Node " + name_string + " encountered:"
			format "%\n" txt
			)
		)
	
	if word == "Tri-mesh" then 
		(
		mesh_reading = true
		txt = "Node is a Tri-Mesh."
		format "%\n" txt
		)

	if word == "Ambient" then 
		(
		ambient_read = true
		format "%\n" "Ambient definition encountered."
		)
		
		
	if word == "Direct" then
		(
		word= read_word file_name
		if word == "light" then 
			(
			read_omni = true
			omni_type = true
			txt = "Node is a Light"
			format "%\n" txt
			)
		)		

	if word == "X" and read_omni == true then
		(		
		pos_x = (read_word file_name) as float
		)
	if word == "Y" 	and read_omni == true then
		(
		pos_y = (read_word file_name) as float
		)
	if word == "Z" and read_omni == true then
		(	
		pos_z = (read_word file_name) as float
		)
		
	if word == "Spotlight" then 
		(
		format "%\n" "Node is Spot Light"
		read_spot = true	
		omni_type = false
		read_omni = false
		)
	
	if word == "Falloff" and read_spot  then
		(	
		word = read_word file_name
		if word == "size" then
			(	
			foff = (read_word file_name) as float
			)
		)
		
	if word == "Hotspot" and read_spot  then
		(	
		word = read_word file_name
		if word == "size" then
			(	
			hspot = (read_word file_name) as float
			)
		)		
		
		
	if word == "X" and read_spot  then
		(		
		s_pos_x = (read_word file_name) as float
		)
	if word == "Y" 	and read_spot then
		(
		s_pos_y = (read_word file_name) as float
		)
	if word == "Z" and read_spot then
		(	
		s_pos_z = (read_word file_name) as float
		)		
		
	if word == "Red"  then
		(	
		o_red = 255 * (read_word file_name) as float
		)
	if word == "Green" then
		(	
		o_green = 255 * (read_word file_name) as float
		)
	if word == "Blue" then
		(	
		o_blue = 255 * (read_word file_name) as float
		
		if ambient_read then
		(
		ambient_read = false
		ambientcolor = [o_red, o_green, o_blue] as color
		)
		
		if read_omni or read_spot then
		(
		read_omni = false
		read_spot = false
		if omni_type then
			(
			o = omnilight pos:[pos_x,pos_y,pos_z] color:([o_red,o_green,o_blue] as color)
			format "%\n" ">Omni Light created."
			)
			else
			(
			ts = targetobject pos:[s_pos_x, s_pos_y, s_pos_z]
			sp = targetspot pos:[pos_x, pos_y, pos_z] color:([o_red,o_green,o_blue] as color) target:ts hotspot:hspot falloff:foff showcone:true
			format "%\n" ">Spot Light created."
			
			)
		)
		)	
		
	if word == "Material" then
		(
		mat_name = read_word file_name
		if num_mats == 0 then 
			(
			matid_array[face_index+1] = 1
			num_mats = 1
			mat_array[1] = mat_name
			)
			else
			(
		mat_read = false
		for i = 1 to num_mats do
			(
			if mat_name == mat_array[i] then 
				(
				matid_array[face_index+1] = i
				mat_read = true
				)
			)
		if mat_read == false then 
			(
			num_mats += 1
			mat_array[num_mats] = mat_name
			matid_array[face_index+1] = num_mats
			)
		)	
		)
		

	if word == "Camera" then
		(
		fov_mm = read_word file_name
		format "%\n" "Node is Target Camera"
		format "%\n" fov_mm
		fov_value = (substring fov_mm 1 (fov_mm.count-2)) as float
		read_camera = true
		)
	if word == "Position" and read_camera == true then
		(
		read_cam_pos = true
		)		
		
		if word == "X" and read_cam_pos == true then
		(		
		c_pos_x = (read_word file_name) as float
	)
	if word == "Y" 	and read_cam_pos== true then
		(
		c_pos_y = (read_word file_name) as float
		)
	if word == "Z" and read_cam_pos == true then
		(	
		c_pos_z = (read_word file_name) as float
		read_cam_pos = false
		)

		
	if word == "Target" and read_camera == true then
		(
		read_target_pos = true
		)		
		if word == "X" and read_target_pos == true then
		(		
		tpos_x = (read_word file_name) as float
		)
	if word == "Y" 	and read_target_pos == true then
		(
		tpos_y = (read_word file_name) as float
		)
	if word == "Z" and read_target_pos == true then
		(	
		tpos_z = (read_word file_name) as float
		read_target_pos = false
		read_camera = false
		ct = targetobject pos:[tpos_x, tpos_y, tpos_z]
		cam = targetcamera pos:[c_pos_x, c_pos_y, c_pos_z] target:ct
		format "%\n" ">Target Camera created."

		)


		
	if word == "Vertices" then 
		(
		vert_count = (read_word file_name) as integer
		txt = "Node has "+ (vert_count as string) + " vertices."
		format "%\n" txt
		)
					
	if word == "Faces" then 
		(
		face_count = (read_word file_name) as integer
		txt = "Node has "+ (face_count as string) + " faces."
		format "%\n" txt
		for i = 1 to face_count do matid_array[i] = 1
		)
	if word == "Mapped" then 
		(
		node_mapped = true
		format "%\n" "Node has Mapping coordinates."
		)		
				
	if word == "Vertex" and read_vertex == false then
		(
		word = read_word file_name
		if word == "list" then 
			(
			vertex_array = #()
			tvertex_array = #()
			read_vertex = true
			format "%\n" "...Reading vertex list..."
			)
		)
	
	if word == "Vertex" and read_vertex == true then
		(
		vert_index = (read_word file_name) as integer
--		format "%\n" vert_index
		)
		
	if word == "X" and read_vertex == true then 
		(
		vert_x = (read_word file_name) as float
--		format "%\n" ("Here is the X " + vert_x as string)
		)
		
	if word == "Y" and read_vertex == true then 
		(
		vert_y = (read_word file_name) as float
--		format "%\n" vert_y
		)
		
	if word == "Z" and read_vertex == true then 
		(
		vert_z = (read_word file_name) as float
--		format "%\n" vert_z
		vertex_array[vert_index+1] = [vert_x, vert_y, vert_z] as point3
			if (vert_index+1) == vert_count then 
			(
			read_vertex = false
			)

		)
								
	if node_mapped then
		(
		if word == "U" then 
			(
			tvert_u = (substring ((read_word file_name)+"0000") 1 4 ) as float
			)
		if word == "V" then 
			(
			tvert_v = (substring ((read_word file_name)+"0000") 1 4 ) as float
			tvertex_array[vert_index+1] = point3 tvert_u tvert_v 0.0 
			)
		)		
		
		
		if word == "Face" and face_read == false then
		(
		word = read_word file_name
		if word == "list" then 
			(
			face_read = true
			face_array = #()
			mat_array = #()
			smooth_array = #()
			for i = 1 to face_count do smooth_array[i] = 0
			edge_array = #()
			vis_ab =#()
			vis_ac =#()
			vis_bc =#()
			format "%\n" "...Reading face list..."
			)
		)
			
		if word == "Face" and face_read == true then
		(			
		face_index = (read_word file_name) as integer
		if (face_index+1) == face_count then
			(
			face_read = false
			wait_for_creation = 1
			)
		)	
		
		if word == "A" then 
		(
		face_a = 1+(read_word file_name) as integer
		)
		
		if word == "B" then 
		(
		face_b = 1+(read_word file_name) as integer
		)
		
		if word == "C" then 
		(
		face_c = 1+(read_word file_name) as integer
		face_array[face_index+1] = [face_a, face_b, face_c]
		)
				
		if word == "AB" then 
		(
		word = (read_word file_name) as integer
		if word == 1 then 
			(
			vis_ab[face_index+1] = true
			)
			else 
			(
			vis_ab[face_index+1] = false
			)
		)
		
		if word == "BC" then 
		(
		word = (read_word file_name) as integer
		if word == 1 then 
			(
			vis_bc[face_index+1] = true 
			)
			else 
			(
			vis_bc[face_index+1] = false
			)
		)
		
		if word == "CA" then 
		(
		word = (read_word file_name) as integer
		if wait_for_creation == 1 then wait_for_creation = 2
		if word == 1 then 
			(
			vis_ac[face_index+1] = true
			)
			else 
			(
			vis_ac[face_index+1] = false
			)
		)
		

		if word == "Smoothing" then 
		(
		read_smoothing = true
		)
		else
		(
		if wait_for_creation == 2 then wait_for_creation = 3
		)
		
		
		
	)--end while not eof
	
	if save_max_file.checked then 
		(
		savemaxfile max_file
		txt = "SCENE SAVED AS "+max_file
		format "%\n" txt
		)
	
	)--end if undefined	
	)--end ofl loop
	
	)--end on open_file



on asc_reader open do
(
check_color = color 255 255 255
check_color *= 255
if check_color.r > 255 then max_ver2 = false else max_ver2= true
)

)